import { type OnDestroy, type OnInit } from '@angular/core';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
export declare const badgeStyles: readonly ["flat", "outline", "flat-with-outline"];
export declare const badgeColors: readonly ["neutral", "gray", "red", "yellow", "amber", "green", "lime", "blue", "sky", "cyan", "teal", "emerald", "indigo", "purple", "pink", "fuchsia", "rose"];
export declare const badgeSizes: readonly ["small", "normal"];
export declare const badgePills: readonly [true, false];
export declare const badgeDots: readonly [true, false];
export declare const badgeSmalls: readonly [true, false];
export type BadgeStyle = (typeof badgeStyles)[number];
export type BadgeColor = (typeof badgeColors)[number];
export type BadgeSize = (typeof badgeSizes)[number];
export declare class BadgeComponent implements OnInit, OnDestroy {
    #private;
    readonly style: import("@angular/core").InputSignal<"flat" | "outline" | "flat-with-outline">;
    readonly color: import("@angular/core").InputSignal<"neutral" | "gray" | "red" | "yellow" | "amber" | "green" | "lime" | "blue" | "sky" | "cyan" | "teal" | "emerald" | "indigo" | "purple" | "pink" | "fuchsia" | "rose">;
    readonly size: import("@angular/core").InputSignal<"small" | "normal">;
    readonly rounded: import("@angular/core").InputSignalWithTransform<boolean, boolean | "false" | "true">;
    readonly pill: import("@angular/core").InputSignalWithTransform<boolean, boolean | "false" | "true">;
    readonly dot: import("@angular/core").InputSignalWithTransform<boolean, boolean | "false" | "true">;
    readonly bold: import("@angular/core").InputSignalWithTransform<boolean, boolean | "false" | "true">;
    readonly interactive: import("@angular/core").InputSignalWithTransform<boolean, boolean | "false" | "true">;
    readonly active: import("@angular/core").InputSignalWithTransform<boolean, boolean | "false" | "true">;
    readonly disabled: import("@angular/core").InputSignalWithTransform<boolean, boolean | "false" | "true">;
    readonly dotColor: Record<"neutral" | "gray" | "red" | "yellow" | "amber" | "green" | "lime" | "blue" | "sky" | "cyan" | "teal" | "emerald" | "indigo" | "purple" | "pink" | "fuchsia" | "rose", string>;
    readonly classes: import("@angular/core").Signal<string>;
    constructor();
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BadgeComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BadgeComponent, "tsl-badge", never, { "style": { "alias": "style"; "required": false; "isSignal": true; }; "color": { "alias": "color"; "required": false; "isSignal": true; }; "size": { "alias": "size"; "required": false; "isSignal": true; }; "rounded": { "alias": "rounded"; "required": false; "isSignal": true; }; "pill": { "alias": "pill"; "required": false; "isSignal": true; }; "dot": { "alias": "dot"; "required": false; "isSignal": true; }; "bold": { "alias": "bold"; "required": false; "isSignal": true; }; "interactive": { "alias": "interactive"; "required": false; "isSignal": true; }; "active": { "alias": "active"; "required": false; "isSignal": true; }; "disabled": { "alias": "disabled"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, [{ directive: typeof i1.NgClass; inputs: {}; outputs: {}; }]>;
}
