import { ChangeDetectorRef, type OnDestroy, type OnInit } from '@angular/core';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
export type ButtonDesign = 'flat' | 'outline' | 'icon' | 'icon-outline' | 'none';
export type ButtonSize = 'normal' | 'small';
export type ButtonColor = 'transparent' | 'white' | 'accent' | 'neutral' | 'stone' | 'red' | 'orange' | 'amber' | 'yellow' | 'lime' | 'green' | 'emerald' | 'teal' | 'cyan' | 'sky' | 'blue' | 'indigo' | 'violet' | 'purple' | 'fuchsia' | 'pink' | 'rose';
export declare class ButtonComponent implements OnInit, OnDestroy {
    #private;
    readonly changeDetector: ChangeDetectorRef;
    readonly design: import("@angular/core").InputSignal<ButtonDesign | null | undefined>;
    readonly color: import("@angular/core").InputSignal<ButtonColor | null | undefined>;
    readonly size: import("@angular/core").InputSignal<ButtonSize | null | undefined>;
    readonly coloredText: import("@angular/core").InputSignalWithTransform<boolean | null | undefined, boolean | "false" | "true" | null | undefined>;
    readonly invertIconPadding: import("@angular/core").InputSignalWithTransform<boolean, boolean | "false" | "true" | null | undefined>;
    readonly disabled: import("@angular/core").InputSignalWithTransform<boolean, boolean | "false" | "true" | null | undefined>;
    readonly inert: import("@angular/core").InputSignalWithTransform<boolean, boolean | "false" | "true" | null | undefined>;
    readonly disabledAttribute: import("@angular/core").Signal<true | null>;
    readonly classes: import("@angular/core").Signal<never>;
    constructor();
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ButtonComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ButtonComponent, "[tslButton]", never, { "design": { "alias": "design"; "required": false; "isSignal": true; }; "color": { "alias": "color"; "required": false; "isSignal": true; }; "size": { "alias": "size"; "required": false; "isSignal": true; }; "coloredText": { "alias": "coloredText"; "required": false; "isSignal": true; }; "invertIconPadding": { "alias": "invertIconPadding"; "required": false; "isSignal": true; }; "disabled": { "alias": "disabled"; "required": false; "isSignal": true; }; "inert": { "alias": "inert"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, [{ directive: typeof i1.NgClass; inputs: {}; outputs: {}; }]>;
}
