import type { Record } from '@tstdl/base/types';
import { CardActionDirective, CardBodyDirective, CardFooterDirective, CardHeaderDirective, CardPostHeaderDirective, CardPreHeaderDirective, CardSubHeaderDirective } from '../../directives';
import * as i0 from "@angular/core";
export declare class CardComponent {
    readonly preHeaders: import("@angular/core").Signal<readonly CardPreHeaderDirective[]>;
    readonly headers: import("@angular/core").Signal<readonly CardHeaderDirective[]>;
    readonly subHeaders: import("@angular/core").Signal<readonly CardSubHeaderDirective[]>;
    readonly postHeaders: import("@angular/core").Signal<readonly CardPostHeaderDirective[]>;
    readonly bodies: import("@angular/core").Signal<readonly CardBodyDirective[]>;
    readonly footers: import("@angular/core").Signal<readonly CardFooterDirective[]>;
    readonly actions: import("@angular/core").Signal<readonly CardActionDirective[]>;
    readonly progress: import("@angular/core").InputSignal<number | undefined>;
    readonly headerSeparator: import("@angular/core").InputSignal<boolean>;
    readonly footerSeparator: import("@angular/core").InputSignal<boolean>;
    readonly padding: import("@angular/core").InputSignal<boolean>;
    readonly loading: import("@angular/core").InputSignal<boolean>;
    readonly footerBackground: import("@angular/core").InputSignal<boolean>;
    readonly headerContainerClass: import("@angular/core").InputSignal<string | string[] | Set<string> | Record<string> | null | undefined>;
    readonly headerOuterContainerClass: import("@angular/core").InputSignal<string | string[] | Set<string> | Record<string> | null | undefined>;
    readonly hasHeader: import("@angular/core").Signal<boolean>;
    readonly hasBody: import("@angular/core").Signal<boolean>;
    readonly hasFooter: import("@angular/core").Signal<boolean>;
    readonly hasAction: import("@angular/core").Signal<boolean>;
    readonly showHeaderSeparator: import("@angular/core").Signal<boolean>;
    readonly showFooterSeparator: import("@angular/core").Signal<boolean>;
    static ɵfac: i0.ɵɵFactoryDeclaration<CardComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CardComponent, "tsl-card, [tslCard]", never, { "progress": { "alias": "progress"; "required": false; "isSignal": true; }; "headerSeparator": { "alias": "headerSeparator"; "required": false; "isSignal": true; }; "footerSeparator": { "alias": "footerSeparator"; "required": false; "isSignal": true; }; "padding": { "alias": "padding"; "required": false; "isSignal": true; }; "loading": { "alias": "loading"; "required": false; "isSignal": true; }; "footerBackground": { "alias": "footerBackground"; "required": false; "isSignal": true; }; "headerContainerClass": { "alias": "headerContainerClass"; "required": false; "isSignal": true; }; "headerOuterContainerClass": { "alias": "headerOuterContainerClass"; "required": false; "isSignal": true; }; }, {}, ["preHeaders", "headers", "subHeaders", "postHeaders", "bodies", "footers", "actions"], ["[tslCardPreHeader]", "[tslCardHeader]", "[tslCardSubHeader]", "[tslCardPostHeader]", "[tslCardBody]", "[tslCardFooter]", "[tslCardAction][slot=left]", "[tslCardAction]", "*"], true, never>;
}
