import type { AfterContentInit, OnChanges } from '@angular/core';
import { ChangeDetectorRef, QueryList } from '@angular/core';
import type { DynamicText } from '@tstdl/base/text';
import type { Record } from '@tstdl/base/types';
import { GridColumnDirective } from '../../directives/grid-column.directive';
import { GridHeaderItemDirective } from '../../directives/grid-header-item.directive';
import { GridItemDirective } from '../../directives/grid-item.directive';
import { GridRowDirective } from '../../directives/grid-row.directive';
import { DataGridOptions } from '../../models';
import * as i0 from "@angular/core";
export type DataGridDisplayType = 'columns' | 'table' | 'items';
export declare class DataGridComponent implements AfterContentInit, OnChanges {
    private readonly changeDetector;
    private contentInit;
    readonly columnClasses: Record<number, string>;
    readonly colSpanClasses: Record<number, string>;
    readonly rowSpanClasses: Record<number, string>;
    heading: DynamicText | undefined;
    displayType: DataGridDisplayType;
    itemColumns: number;
    booleanTrueText: DynamicText | null | undefined;
    booleanFalseText: DynamicText | null | undefined;
    noValueText: DynamicText | null | undefined;
    headerItemRefs: QueryList<GridHeaderItemDirective>;
    itemRefs: QueryList<GridItemDirective>;
    columnRefs: QueryList<GridColumnDirective>;
    rowRefs: QueryList<GridRowDirective>;
    matrix: (GridItemDirective | undefined)[][];
    columns: number;
    actualDisplayType: DataGridDisplayType;
    get empty(): boolean;
    constructor(changeDetector: ChangeDetectorRef, options?: DataGridOptions | null);
    ngAfterContentInit(): void;
    ngOnChanges(): void;
    isOddItemsRow(index: number): boolean;
    private update;
    private updateMatrix;
    private updateActualDisplayType;
    trackBy(_index: number, _item: any): true;
    static ɵfac: i0.ɵɵFactoryDeclaration<DataGridComponent, [null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DataGridComponent, "tsl-data-grid", never, { "heading": { "alias": "heading"; "required": false; }; "displayType": { "alias": "displayType"; "required": false; }; "itemColumns": { "alias": "itemColumns"; "required": false; }; "booleanTrueText": { "alias": "booleanTrueText"; "required": false; }; "booleanFalseText": { "alias": "booleanFalseText"; "required": false; }; "noValueText": { "alias": "noValueText"; "required": false; }; }, {}, ["headerItemRefs", "itemRefs", "columnRefs", "rowRefs"], never, true, never>;
}
