import { TemplateRef } from '@angular/core';
import type { DynamicText } from '@tstdl/base/text';
import type { Enumeration } from '@tstdl/base/types';
import type { GridValue } from '../models/grid-value';
import type { GridValueType } from '../models/grid-value-type';
import { GridLabelDirective } from './grid-label.directive';
import { GridValueDirective } from './grid-value.directive';
import * as i0 from "@angular/core";
export declare class GridItemDirective {
    private readonly templateRef;
    label: DynamicText | null | undefined;
    value: GridValue | null | undefined;
    valueType: GridValueType | null | undefined;
    enum: Enumeration | null | undefined;
    nullValue: GridValue | null | undefined;
    suffix: string | null | undefined;
    colSpan: number | null | undefined;
    rowSpan: number | null | undefined;
    booleanTrueText: DynamicText | null | undefined;
    booleanFalseText: DynamicText | null | undefined;
    noValueText: DynamicText | null | undefined;
    labelRef: GridLabelDirective | null | undefined;
    valueRef: GridValueDirective | null | undefined;
    set gridItem(label: DynamicText | null | undefined);
    get labelTemplateRef(): TemplateRef<void> | null | undefined;
    get valueTemplateRef(): TemplateRef<void> | null | undefined;
    constructor(templateRef: TemplateRef<void> | null);
    static ɵfac: i0.ɵɵFactoryDeclaration<GridItemDirective, [{ optional: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<GridItemDirective, "[gridItem]", ["gridItem"], { "label": { "alias": "label"; "required": false; }; "value": { "alias": "value"; "required": false; }; "valueType": { "alias": "valueType"; "required": false; }; "enum": { "alias": "enum"; "required": false; }; "nullValue": { "alias": "nullValue"; "required": false; }; "suffix": { "alias": "suffix"; "required": false; }; "colSpan": { "alias": "colSpan"; "required": false; }; "rowSpan": { "alias": "rowSpan"; "required": false; }; "booleanTrueText": { "alias": "booleanTrueText"; "required": false; }; "booleanFalseText": { "alias": "booleanFalseText"; "required": false; }; "noValueText": { "alias": "noValueText"; "required": false; }; "gridItem": { "alias": "gridItem"; "required": false; }; }, {}, ["labelRef", "valueRef"], never, true, never>;
}
