import * as i0 from '@angular/core';
import { inject, output, signal, effect, HostListener, ViewEncapsulation, ChangeDetectionStrategy, Component, input, contentChild, model, booleanAttribute, afterNextRender, NgModule } from '@angular/core';
import { MatRipple } from '@angular/material/core';
import { collapseAnimation } from '@tstdl/angular';

class DrawerCardContentComponent {
    #ripple;
    constructor() {
        this.#ripple = inject(MatRipple);
        this.clicked = output();
        this.interactive = signal(false);
        effect(() => (this.#ripple.disabled = !this.interactive()));
    }
    ngOnInit() {
        this.#ripple.ngOnInit();
    }
    ngOnDestroy() {
        this.#ripple.ngOnDestroy();
    }
    onClick() {
        this.clicked.emit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: DrawerCardContentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.9", type: DrawerCardContentComponent, isStandalone: true, selector: "tsl-drawer-card-content", outputs: { clicked: "clicked" }, host: { listeners: { "click": "onClick()" }, properties: { "class.interactive": "interactive()" } }, providers: [MatRipple], ngImport: i0, template: "<ng-content></ng-content>\n", styles: ["@layer tstdl.components{tsl-drawer-card-content{position:relative;z-index:10;margin:-1px;display:block;overflow:clip;border-radius:.5rem;border-width:1px;border-color:rgb(var(--tsl-color-neutral-500) / .25);--tw-bg-opacity: 1;background-color:rgb(255 255 255 / var(--tw-bg-opacity, 1));padding:1rem;--tw-shadow: 0 1px 3px 0 rgb(0 0 0 / .1), 0 1px 2px -1px rgb(0 0 0 / .1);--tw-shadow-colored: 0 1px 3px 0 var(--tw-shadow-color), 0 1px 2px -1px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow, 0 0 #0000),var(--tw-ring-shadow, 0 0 #0000),var(--tw-shadow);transition-property:background,border;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.3s}tsl-drawer-card-content:is(.tsl-dark *){border-color:rgb(var(--tsl-color-neutral-200) / .25);--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-800) / var(--tw-bg-opacity, 1))}tsl-drawer-card-content.interactive{cursor:pointer}tsl-drawer-card-content.interactive:hover{--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-50) / var(--tw-bg-opacity, 1))}tsl-drawer-card-content.interactive:hover:is(.tsl-dark *){background-color:rgb(var(--tsl-color-neutral-800) / .5)}}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: DrawerCardContentComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tsl-drawer-card-content', imports: [], changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, providers: [MatRipple], host: {
                        '[class.interactive]': 'interactive()'
                    }, template: "<ng-content></ng-content>\n", styles: ["@layer tstdl.components{tsl-drawer-card-content{position:relative;z-index:10;margin:-1px;display:block;overflow:clip;border-radius:.5rem;border-width:1px;border-color:rgb(var(--tsl-color-neutral-500) / .25);--tw-bg-opacity: 1;background-color:rgb(255 255 255 / var(--tw-bg-opacity, 1));padding:1rem;--tw-shadow: 0 1px 3px 0 rgb(0 0 0 / .1), 0 1px 2px -1px rgb(0 0 0 / .1);--tw-shadow-colored: 0 1px 3px 0 var(--tw-shadow-color), 0 1px 2px -1px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow, 0 0 #0000),var(--tw-ring-shadow, 0 0 #0000),var(--tw-shadow);transition-property:background,border;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.3s}tsl-drawer-card-content:is(.tsl-dark *){border-color:rgb(var(--tsl-color-neutral-200) / .25);--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-800) / var(--tw-bg-opacity, 1))}tsl-drawer-card-content.interactive{cursor:pointer}tsl-drawer-card-content.interactive:hover{--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-50) / var(--tw-bg-opacity, 1))}tsl-drawer-card-content.interactive:hover:is(.tsl-dark *){background-color:rgb(var(--tsl-color-neutral-800) / .5)}}\n"] }]
        }], ctorParameters: () => [], propDecorators: { onClick: [{
                type: HostListener,
                args: ['click']
            }] } });

class DrawerCardDrawerContentComponent {
    constructor() {
        this.containerClasses = input(null);
        this.open = signal(false);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: DrawerCardDrawerContentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.2.9", type: DrawerCardDrawerContentComponent, isStandalone: true, selector: "tsl-drawer-card-drawer-content", inputs: { containerClasses: { classPropertyName: "containerClasses", publicName: "containerClasses", isSignal: true, isRequired: false, transformFunction: null } }, host: { properties: { "class.drawer-collapse": "!open()" } }, ngImport: i0, template: "<ng-content></ng-content>\n", styles: ["@layer tstdl.components{tsl-drawer-card-drawer-content{display:block;padding:1rem;transition-property:background,transform,opacity;transition-duration:.3s;transition-timing-function:cubic-bezier(.4,0,.2,1)}tsl-drawer-card-drawer-content.drawer-collapse{--tw-translate-y: -100%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));opacity:0}}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: DrawerCardDrawerContentComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tsl-drawer-card-drawer-content', imports: [], changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, host: {
                        '[class.drawer-collapse]': '!open()'
                    }, template: "<ng-content></ng-content>\n", styles: ["@layer tstdl.components{tsl-drawer-card-drawer-content{display:block;padding:1rem;transition-property:background,transform,opacity;transition-duration:.3s;transition-timing-function:cubic-bezier(.4,0,.2,1)}tsl-drawer-card-drawer-content.drawer-collapse{--tw-translate-y: -100%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));opacity:0}}\n"] }]
        }] });

class DrawerCardComponent {
    constructor() {
        this.contentComponent = contentChild(DrawerCardContentComponent);
        this.drawerContentComponent = contentChild(DrawerCardDrawerContentComponent);
        this.open = model(false);
        this.manualOpen = input(false, { transform: booleanAttribute });
        this.interactive = input(true, { transform: booleanAttribute });
        effect(() => this.drawerContentComponent()?.open.set(this.open()));
        effect(() => this.contentComponent()?.interactive.set(this.interactive()));
        afterNextRender({
            read: () => this.contentComponent()?.clicked.subscribe(() => {
                if (!this.manualOpen()) {
                    this.open.update((open) => !open);
                }
            })
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: DrawerCardComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.9", type: DrawerCardComponent, isStandalone: true, selector: "tsl-drawer-card", inputs: { open: { classPropertyName: "open", publicName: "open", isSignal: true, isRequired: false, transformFunction: null }, manualOpen: { classPropertyName: "manualOpen", publicName: "manualOpen", isSignal: true, isRequired: false, transformFunction: null }, interactive: { classPropertyName: "interactive", publicName: "interactive", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { open: "openChange" }, host: { classAttribute: "tsl-tw" }, queries: [{ propertyName: "contentComponent", first: true, predicate: DrawerCardContentComponent, descendants: true, isSignal: true }, { propertyName: "drawerContentComponent", first: true, predicate: DrawerCardDrawerContentComponent, descendants: true, isSignal: true }], ngImport: i0, template: "<ng-content select=\"tsl-drawer-card-content\"></ng-content>\n\n@defer {\n  <div [@collapse]=\"!open()\" class=\"drawer-container\" [ngClass]=\"drawerContentComponent()?.containerClasses()\">\n    <ng-content select=\"tsl-drawer-card-drawer-content\"></ng-content>\n  </div>\n}\n", styles: ["@layer tstdl.components{tsl-drawer-card{display:block;overflow:clip;border-radius:.5rem;border-width:1px;border-color:rgb(var(--tsl-color-neutral-500) / .25);--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-100) / var(--tw-bg-opacity, 1));--tw-shadow: 0 1px 3px 0 rgb(0 0 0 / .1), 0 1px 2px -1px rgb(0 0 0 / .1);--tw-shadow-colored: 0 1px 3px 0 var(--tw-shadow-color), 0 1px 2px -1px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow, 0 0 #0000),var(--tw-ring-shadow, 0 0 #0000),var(--tw-shadow)}tsl-drawer-card:is(.tsl-dark *){border-color:rgb(var(--tsl-color-neutral-400) / .25);--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-700) / var(--tw-bg-opacity, 1))}tsl-drawer-card .drawer-container{overflow:clip}}\n"], animations: [collapseAnimation({ duration: 300, ease: 'cubic-bezier(0.4, 0, 0.2, 1)' })], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None, deferBlockDependencies: [() => [import('@angular/common').then(m => m.NgClass)]] }); }
}
i0.ɵɵngDeclareClassMetadataAsync({ minVersion: "18.0.0", version: "19.2.9", ngImport: i0, type: DrawerCardComponent, resolveDeferredDeps: () => [import('@angular/common').then(m => m.NgClass)], resolveMetadata: NgClass => ({ decorators: [{
                type: Component,
                args: [{ selector: 'tsl-drawer-card', imports: [NgClass], animations: [collapseAnimation({ duration: 300, ease: 'cubic-bezier(0.4, 0, 0.2, 1)' })], changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, host: {
                            class: 'tsl-tw'
                        }, template: "<ng-content select=\"tsl-drawer-card-content\"></ng-content>\n\n@defer {\n  <div [@collapse]=\"!open()\" class=\"drawer-container\" [ngClass]=\"drawerContentComponent()?.containerClasses()\">\n    <ng-content select=\"tsl-drawer-card-drawer-content\"></ng-content>\n  </div>\n}\n", styles: ["@layer tstdl.components{tsl-drawer-card{display:block;overflow:clip;border-radius:.5rem;border-width:1px;border-color:rgb(var(--tsl-color-neutral-500) / .25);--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-100) / var(--tw-bg-opacity, 1));--tw-shadow: 0 1px 3px 0 rgb(0 0 0 / .1), 0 1px 2px -1px rgb(0 0 0 / .1);--tw-shadow-colored: 0 1px 3px 0 var(--tw-shadow-color), 0 1px 2px -1px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow, 0 0 #0000),var(--tw-ring-shadow, 0 0 #0000),var(--tw-shadow)}tsl-drawer-card:is(.tsl-dark *){border-color:rgb(var(--tsl-color-neutral-400) / .25);--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-700) / var(--tw-bg-opacity, 1))}tsl-drawer-card .drawer-container{overflow:clip}}\n"] }]
            }], ctorParameters: () => [], propDecorators: null }) });

class TslDrawerCardModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: TslDrawerCardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.9", ngImport: i0, type: TslDrawerCardModule, imports: [DrawerCardComponent, DrawerCardContentComponent, DrawerCardDrawerContentComponent], exports: [DrawerCardComponent, DrawerCardContentComponent, DrawerCardDrawerContentComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: TslDrawerCardModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: TslDrawerCardModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [DrawerCardComponent, DrawerCardContentComponent, DrawerCardDrawerContentComponent],
                    exports: [DrawerCardComponent, DrawerCardContentComponent, DrawerCardDrawerContentComponent]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { DrawerCardComponent, DrawerCardContentComponent, DrawerCardDrawerContentComponent, TslDrawerCardModule };
//# sourceMappingURL=tstdl-angular-drawer-card.mjs.map
