import { NgClass } from '@angular/common';
import * as i0 from '@angular/core';
import { inject, ElementRef, Renderer2, ChangeDetectorRef, signal, effect, Input, Directive, isSignal, computed } from '@angular/core';
import { resolveValueOrProvider } from '@tstdl/base/utils';

class TslHostClass {
    #ngClass = new NgClass(inject(ElementRef), inject(Renderer2));
    #changeDetector = inject(ChangeDetectorRef);
    #classes = signal(null);
    get classes() {
        return this.#classes();
    }
    set classes(classes) {
        this.#classes.set(classes);
    }
    constructor() {
        effect(() => {
            this.#ngClass.ngClass = this.#classes();
            this.#ngClass.ngDoCheck();
            this.#changeDetector.markForCheck();
        });
    }
    ngDoCheck() {
        this.#ngClass.ngDoCheck();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: TslHostClass, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.2.9", type: TslHostClass, isStandalone: true, selector: "[tslHostClass]", inputs: { classes: "classes" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: TslHostClass, decorators: [{
            type: Directive,
            args: [{
                    selector: '[tslHostClass]',
                    standalone: true
                }]
        }], ctorParameters: () => [], propDecorators: { classes: [{
                type: Input
            }] } });
function hostClass(classes) {
    const instance = new TslHostClass();
    const inputSignal = isSignal(classes) ? classes : computed(() => resolveValueOrProvider(classes));
    effect(() => (instance.classes = inputSignal()));
    return instance;
}

/**
 * Generated bundle index. Do not edit.
 */

export { TslHostClass, hostClass };
//# sourceMappingURL=tstdl-angular-host-class.mjs.map
