import * as i0 from '@angular/core';
import { input, ChangeDetectionStrategy, Component } from '@angular/core';
import { pipe } from '@tstdl/base/signals';
import * as i1 from 'ngx-extended-pdf-viewer';
import { NgxExtendedPdfViewerModule } from 'ngx-extended-pdf-viewer';
import { switchMap, of, delay, startWith } from 'rxjs';

class PdfViewerComponent {
    constructor() {
        this.darkMode = input(false);
        this.source = input();
        this.url = pipe(this.source, switchMap((source) => of(source).pipe(delay(1), startWith(undefined))));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: PdfViewerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.9", type: PdfViewerComponent, isStandalone: true, selector: "tsl-pdf-viewer", inputs: { darkMode: { classPropertyName: "darkMode", publicName: "darkMode", isSignal: true, isRequired: false, transformFunction: null }, source: { classPropertyName: "source", publicName: "source", isSignal: true, isRequired: false, transformFunction: null } }, host: { classAttribute: "block" }, ngImport: i0, template: "@if (url(); as url) {\n  <ngx-extended-pdf-viewer\n    class=\"contain-strict\"\n    [src]=\"url\"\n    [authorization]=\"true\"\n    zoom=\"auto\"\n    [theme]=\"darkMode() ? 'dark' : 'light'\"\n    [handTool]=\"false\"\n    [showOpenFileButton]=\"false\"\n    [showDrawEditor]=\"false\"\n    [showTextEditor]=\"false\"\n    [showInfiniteScrollButton]=\"false\"\n    [showRotateButton]=\"false\"\n    [showStampEditor]=\"false\"\n    [showHighlightEditor]=\"false\"></ngx-extended-pdf-viewer>\n}\n", styles: [""], dependencies: [{ kind: "ngmodule", type: NgxExtendedPdfViewerModule }, { kind: "component", type: i1.NgxExtendedPdfViewerComponent, selector: "ngx-extended-pdf-viewer", inputs: ["customFindbarInputArea", "customToolbar", "customFindbar", "customFindbarButtons", "customPdfViewer", "customSecondaryToolbar", "customSidebar", "customThumbnail", "customFreeFloatingBar", "showFreeFloatingBar", "enableDragAndDrop", "forceUsingLegacyES5", "formData", "disableForms", "pageViewMode", "scrollMode", "authorization", "httpHeaders", "contextMenuAllowed", "enablePrint", "enablePrintAutoRotate", "forceFullReloadOfJavaScriptCode", "showTextEditor", "showStampEditor", "showDrawEditor", "showHighlightEditor", "logLevel", "relativeCoordsOptions", "minifiedJSLibraries", "printResolution", "rotation", "src", "base64Src", "minHeight", "height", "backgroundColor", "filenameForDownload", "ignoreKeyboard", "ignoreKeys", "acceptKeys", "imageResourcesPath", "localeFolderPath", "language", "listenToURL", "nameddest", "password", "replaceBrowserPrint", "useInlineScripts", "showUnverifiedSignatures", "startTabindex", "showSidebarButton", "sidebarVisible", "activeSidebarView", "findbarVisible", "propertiesDialogVisible", "showFindButton", "showFindHighlightAll", "showFindMatchCase", "showFindMultiple", "showFindRegexp", "showFindEntireWord", "showFindMatchDiacritics", "showFindResultsCount", "showFindMessages", "showPagingButtons", "showFirstAndLastPageButtons", "showPreviousAndNextPageButtons", "showPageNumber", "showPageLabel", "showZoomButtons", "showZoomDropdown", "showPresentationModeButton", "showOpenFileButton", "showPrintButton", "showDownloadButton", "theme", "showToolbar", "showSecondaryToolbarButton", "showSinglePageModeButton", "showVerticalScrollButton", "showHorizontalScrollButton", "showWrappedScrollButton", "showInfiniteScrollButton", "showBookModeButton", "showRotateButton", "showRotateCwButton", "showRotateCcwButton", "handTool", "showHandToolButton", "showSpreadButton", "showPropertiesButton", "showBorders", "spread", "showScrollingButtons", "page", "pageLabel", "textLayer", "zoom", "zoomLevels", "maxZoom", "minZoom", "mobileFriendlyZoom"], outputs: ["annotationEditorEvent", "formDataChange", "pageViewModeChange", "progress", "srcChange", "scrollModeChange", "afterPrint", "beforePrint", "currentZoomFactor", "rotationChange", "annotationLayerRendered", "annotationEditorLayerRendered", "xfaLayerRendered", "outlineLoaded", "attachmentsloaded", "layersloaded", "sidebarVisibleChange", "activeSidebarViewChange", "findbarVisibleChange", "propertiesDialogVisibleChange", "handToolChange", "spreadChange", "thumbnailDrawn", "pageChange", "pageLabelChange", "pagesLoaded", "pageRender", "pageRendered", "pdfDownloaded", "pdfLoaded", "pdfLoadingStarts", "pdfLoadingFailed", "textLayerRendered", "annotationEditorModeChanged", "updateFindMatchesCount", "updateFindState", "zoomChange"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: PdfViewerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tsl-pdf-viewer', imports: [NgxExtendedPdfViewerModule], changeDetection: ChangeDetectionStrategy.OnPush, host: {
                        class: 'block'
                    }, template: "@if (url(); as url) {\n  <ngx-extended-pdf-viewer\n    class=\"contain-strict\"\n    [src]=\"url\"\n    [authorization]=\"true\"\n    zoom=\"auto\"\n    [theme]=\"darkMode() ? 'dark' : 'light'\"\n    [handTool]=\"false\"\n    [showOpenFileButton]=\"false\"\n    [showDrawEditor]=\"false\"\n    [showTextEditor]=\"false\"\n    [showInfiniteScrollButton]=\"false\"\n    [showRotateButton]=\"false\"\n    [showStampEditor]=\"false\"\n    [showHighlightEditor]=\"false\"></ngx-extended-pdf-viewer>\n}\n" }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { PdfViewerComponent };
//# sourceMappingURL=tstdl-angular-pdf-viewer.mjs.map
