import * as i0 from '@angular/core';
import { model, ViewEncapsulation, ChangeDetectionStrategy, Component, inject, ElementRef, ViewContainerRef, TemplateRef, isSignal, Input, Directive } from '@angular/core';
import { fadeInOutAnimation, DynamicTextPipe } from '@tstdl/angular';
import { Overlay, OverlayPositionBuilder } from '@angular/cdk/overlay';
import { TemplatePortal, ComponentPortal } from '@angular/cdk/portal';
import { isNull, isFunction, isDefined, isNotNullOrUndefined, isString } from '@tstdl/base/utils';
import { merge, fromEvent, map, switchMap, of, delay, distinctUntilChanged, isObservable } from 'rxjs';

class TooltipComponent {
    constructor() {
        this.text = model();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: TooltipComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.9", type: TooltipComponent, isStandalone: true, selector: "tsl-tooltip", inputs: { text: { classPropertyName: "text", publicName: "text", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { text: "textChange" }, host: { properties: { "@fadeInOut": "true" } }, ngImport: i0, template: "<ng-content></ng-content>\n\n@if (text(); as text) {\n  <span>{{ text | dynamicText }}</span>\n}\n", styles: ["@layer tstdl.components{tsl-tooltip{display:block;width:max-content;border-radius:.375rem;border-width:1px;border-color:rgb(var(--tsl-color-neutral-300) / .6);--tw-bg-opacity: 1;background-color:rgb(255 255 255 / var(--tw-bg-opacity, 1));padding:.125rem .5rem;--tw-text-opacity: 1;color:rgb(var(--tsl-color-neutral-800) / var(--tw-text-opacity, 1));--tw-shadow: 0 1px 3px 0 rgb(0 0 0 / .1), 0 1px 2px -1px rgb(0 0 0 / .1);--tw-shadow-colored: 0 1px 3px 0 var(--tw-shadow-color), 0 1px 2px -1px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow, 0 0 #0000),var(--tw-ring-shadow, 0 0 #0000),var(--tw-shadow)}tsl-tooltip:is(.tsl-dark *){border-width:1px;--tw-border-opacity: 1;border-color:rgb(var(--tsl-color-neutral-800) / var(--tw-border-opacity, 1));--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-700) / var(--tw-bg-opacity, 1));--tw-text-opacity: 1;color:rgb(var(--tsl-color-neutral-300) / var(--tw-text-opacity, 1))}}\n"], dependencies: [{ kind: "pipe", type: DynamicTextPipe, name: "dynamicText" }], animations: [
            fadeInOutAnimation()
        ], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: TooltipComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tsl-tooltip', imports: [DynamicTextPipe], changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, animations: [
                        fadeInOutAnimation()
                    ], host: {
                        '[@fadeInOut]': 'true'
                    }, template: "<ng-content></ng-content>\n\n@if (text(); as text) {\n  <span>{{ text | dynamicText }}</span>\n}\n", styles: ["@layer tstdl.components{tsl-tooltip{display:block;width:max-content;border-radius:.375rem;border-width:1px;border-color:rgb(var(--tsl-color-neutral-300) / .6);--tw-bg-opacity: 1;background-color:rgb(255 255 255 / var(--tw-bg-opacity, 1));padding:.125rem .5rem;--tw-text-opacity: 1;color:rgb(var(--tsl-color-neutral-800) / var(--tw-text-opacity, 1));--tw-shadow: 0 1px 3px 0 rgb(0 0 0 / .1), 0 1px 2px -1px rgb(0 0 0 / .1);--tw-shadow-colored: 0 1px 3px 0 var(--tw-shadow-color), 0 1px 2px -1px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow, 0 0 #0000),var(--tw-ring-shadow, 0 0 #0000),var(--tw-shadow)}tsl-tooltip:is(.tsl-dark *){border-width:1px;--tw-border-opacity: 1;border-color:rgb(var(--tsl-color-neutral-800) / var(--tw-border-opacity, 1));--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-700) / var(--tw-bg-opacity, 1));--tw-text-opacity: 1;color:rgb(var(--tsl-color-neutral-300) / var(--tw-text-opacity, 1))}}\n"] }]
        }] });

class TooltipDirective {
    constructor() {
        this.elementRef = inject(ElementRef);
        this.viewContainerRef = inject(ViewContainerRef);
        this.overlay = inject(Overlay);
        this.overlayPositionBuilder = inject(OverlayPositionBuilder);
        this.tooltipContainer = true;
        this.tooltipDelay = 500;
        const mouseEvent$ = merge(fromEvent(this.elementRef.nativeElement, 'mouseenter').pipe(map(() => 'enter')), fromEvent(this.elementRef.nativeElement, 'mouseleave').pipe(map(() => 'leave')));
        this.subscription = mouseEvent$
            .pipe(switchMap((event) => (event == 'enter' ? of(true).pipe(delay(this.tooltipDelay)) : of(false))), distinctUntilChanged())
            .subscribe((show) => (show ? this.show() : this.hide()));
        this.positionStrategy = this.overlayPositionBuilder
            .flexibleConnectedTo(this.elementRef)
            .withPositions([{
                originX: 'center',
                originY: 'top',
                overlayX: 'center',
                overlayY: 'bottom'
            }])
            .withViewportMargin(5)
            .withDefaultOffsetY(-5)
            .withPush(true);
    }
    ngOnDestroy() {
        this.hide();
        this.subscription.unsubscribe();
    }
    show() {
        if (isNull(this.content)) {
            return;
        }
        this.overlayRef = this.overlay.create({ positionStrategy: this.positionStrategy });
        const templatePortal = (this.content instanceof TemplatePortal)
            ? this.content
            : (this.content instanceof TemplateRef)
                ? new TemplatePortal(this.content, this.viewContainerRef)
                : undefined;
        const componentPortal = (this.content instanceof ComponentPortal)
            ? this.content
            : (isFunction(this.content) && !isSignal(this.content))
                ? new ComponentPortal(this.content, this.viewContainerRef)
                : undefined;
        if (isDefined(templatePortal)) {
            this.tooltipViewRef = this.overlayRef.attach(templatePortal);
            if (isNotNullOrUndefined(this.tooltipContext)) {
                this.tooltipViewRef.context = this.tooltipContext;
            }
        }
        else if (isDefined(componentPortal)) {
            this.tooltipComponentRef = this.overlayRef.attach(this.content);
        }
        else {
            const tooltipComponentPortal = new ComponentPortal(TooltipComponent);
            const tooltipComponentRef = this.overlayRef.attach(tooltipComponentPortal);
            if (isString(this.content) || isSignal(this.content) || isObservable(this.content)) {
                tooltipComponentRef.instance.text.set(this.content);
            }
        }
    }
    hide() {
        this.overlayRef?.dispose();
        this.tooltipViewRef = undefined;
        this.tooltipComponentRef = undefined;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: TooltipDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.2.9", type: TooltipDirective, isStandalone: true, selector: "[tslTooltip]", inputs: { content: ["tslTooltip", "content"], tooltipContainer: "tooltipContainer", tooltipContext: "tooltipContext", tooltipDelay: "tooltipDelay" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: TooltipDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[tslTooltip]'
                }]
        }], ctorParameters: () => [], propDecorators: { content: [{
                type: Input,
                args: ['tslTooltip']
            }], tooltipContainer: [{
                type: Input
            }], tooltipContext: [{
                type: Input
            }], tooltipDelay: [{
                type: Input
            }] } });

/**
 * Generated bundle index. Do not edit.
 */

export { TooltipComponent, TooltipDirective };
//# sourceMappingURL=tstdl-angular-tooltip.mjs.map
