import * as i0 from '@angular/core';
import { inject, TemplateRef, Directive, viewChild, contentChild, input, computed, ViewEncapsulation, ChangeDetectionStrategy, Component, contentChildren, viewChildren, ElementRef, model, effect, NgModule } from '@angular/core';
import { NgTemplateOutlet, NgClass } from '@angular/common';
import { DynamicTextPipe } from '@tstdl/angular';
import { IconComponent } from '@tstdl/angular/icon';
import { isNull } from '@tstdl/base/utils';

class VerticalTabLabelDirective {
    constructor() {
        this.templateRef = inject(TemplateRef, { optional: true });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: VerticalTabLabelDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.2.9", type: VerticalTabLabelDirective, isStandalone: true, selector: "[verticalTabLabel]", exportAs: ["verticalTabLabel"], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: VerticalTabLabelDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[verticalTabLabel]',
                    exportAs: 'verticalTabLabel',
                    standalone: true
                }]
        }] });

class VerticalTabComponent {
    constructor() {
        this.contentTemplate = viewChild(TemplateRef);
        this.labelRef = contentChild(VerticalTabLabelDirective);
        this.label = input();
        this.description = input();
        this.icon = input();
        this.class = input();
        this.labelTemplateRef = computed(() => this.labelRef()?.templateRef);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: VerticalTabComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.2.0", version: "19.2.9", type: VerticalTabComponent, isStandalone: true, selector: "tsl-vertical-tab", inputs: { label: { classPropertyName: "label", publicName: "label", isSignal: true, isRequired: false, transformFunction: null }, description: { classPropertyName: "description", publicName: "description", isSignal: true, isRequired: false, transformFunction: null }, icon: { classPropertyName: "icon", publicName: "icon", isSignal: true, isRequired: false, transformFunction: null }, class: { classPropertyName: "class", publicName: "class", isSignal: true, isRequired: false, transformFunction: null } }, queries: [{ propertyName: "labelRef", first: true, predicate: VerticalTabLabelDirective, descendants: true, isSignal: true }], viewQueries: [{ propertyName: "contentTemplate", first: true, predicate: TemplateRef, descendants: true, isSignal: true }], ngImport: i0, template: "<ng-template>\n  <ng-content></ng-content>\n</ng-template>\n", styles: [""], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: VerticalTabComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tsl-vertical-tab', imports: [], changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, template: "<ng-template>\n  <ng-content></ng-content>\n</ng-template>\n" }]
        }] });

class VerticalTabGroupComponent {
    constructor() {
        this.tabs = contentChildren(VerticalTabComponent);
        this.tabContainers = viewChildren('tabContainer', { read: ElementRef });
        this.title = input();
        this.selectedTabIndex = model(null);
        this.selectedTab = computed(() => this.tabs()[this.selectedTabIndex()] ?? null);
        effect(() => {
            if (this.tabs().length == 0) {
                this.selectedTabIndex.set(null);
            }
            const currentIndex = this.selectedTabIndex();
            if (isNull(currentIndex) || (currentIndex >= this.tabs().length)) {
                this.selectedTabIndex.set(0);
            }
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: VerticalTabGroupComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.9", type: VerticalTabGroupComponent, isStandalone: true, selector: "tsl-vertical-tab-group", inputs: { title: { classPropertyName: "title", publicName: "title", isSignal: true, isRequired: false, transformFunction: null }, selectedTabIndex: { classPropertyName: "selectedTabIndex", publicName: "selectedTabIndex", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { selectedTabIndex: "selectedTabIndexChange" }, host: { classAttribute: "tsl-tw" }, queries: [{ propertyName: "tabs", predicate: VerticalTabComponent, isSignal: true }], viewQueries: [{ propertyName: "tabContainers", predicate: ["tabContainer"], descendants: true, read: ElementRef, isSignal: true }], ngImport: i0, template: "<div class=\"border-r self-stretch\">\n  @if (title(); as title) {\n    <div class=\"tab-title-container\">\n      <div>{{ title | dynamicText }}</div>\n    </div>\n  }\n\n  <div>\n    @for (tab of tabs(); track tab) {\n      <div class=\"tab\" (click)=\"selectedTabIndex.set(tabs().indexOf(tab))\" [class.tab-selected]=\"tab == selectedTab()\">\n        <div class=\"flex items-center gap-2\">\n          @if (tab.icon(); as icon) {\n            <tsl-icon [icon]=\"icon\" size=\"2xl\"></tsl-icon>\n          }\n          <div class=\"tab-label\">\n            @if (tab.labelTemplateRef(); as labelTemplateRef) {\n              <ng-container [ngTemplateOutlet]=\"labelTemplateRef\"></ng-container>\n            } @else {\n              {{ tab.label() | dynamicText }}\n            }\n          </div>\n        </div>\n\n        @if (tab.description(); as description) {\n          <div class=\"tab-description\">{{ description | dynamicText }}</div>\n        }\n      </div>\n    }\n  </div>\n</div>\n\n<div class=\"tabs-container\">\n  @for (tab of tabs(); let index = $index; track tab) {\n    <div\n      class=\"tab-container\"\n      [class.opacity-0]=\"index != selectedTabIndex()\"\n      [class.pointer-events-none]=\"index != selectedTabIndex()\"\n      [attr.inert]=\"index != selectedTabIndex() ? true : null\"\n      [ngClass]=\"tab.class()\">\n      <ng-container [ngTemplateOutlet]=\"tab.contentTemplate() ?? null\"></ng-container>\n    </div>\n  }\n</div>\n", styles: ["@layer tstdl.components{tsl-vertical-tab-group{display:grid;grid-template-columns:auto 1fr;--tw-bg-opacity: 1;background-color:rgb(255 255 255 / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group:is(.tsl-dark *){--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-800) / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group .tab{position:relative;cursor:pointer;border-bottom-width:1px;padding:1rem 1.5rem}tsl-vertical-tab-group .tab:last-child{border-bottom-width:0px}tsl-vertical-tab-group .tab:not(.tab-selected):hover{--tw-bg-opacity: 1;background-color:rgb(255 251 235 / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group .tab:not(.tab-selected):is(.tsl-dark *):hover{background-color:rgb(var(--tsl-color-neutral-500) / .2)}tsl-vertical-tab-group .tab-selected{--tw-bg-opacity: 1;background-color:rgb(254 243 199 / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group .tab-selected:after{position:absolute;right:0;top:0;bottom:0;border-color:rgb(var(--tsl-color-neutral-500) / .8);content:var(--tw-content);transition-property:border;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}tsl-vertical-tab-group .tab-selected:is(.tsl-dark *){--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-700) / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group .tab-selected:is(.tsl-dark *):after{content:var(--tw-content);border-right-width:1px}tsl-vertical-tab-group .tab-selected .tab-label{--tw-text-opacity: 1;color:rgb(217 119 6 / var(--tw-text-opacity, 1))}tsl-vertical-tab-group .tab-selected .tab-label:is(.tsl-dark *){--tw-text-opacity: 1;color:rgb(245 158 11 / var(--tw-text-opacity, 1))}tsl-vertical-tab-group .tab-title-container{border-bottom-width:1px;padding:1.5rem;font-size:1.875rem;line-height:2.25rem;font-weight:700}tsl-vertical-tab-group .tab-label{font-weight:600}tsl-vertical-tab-group .tab-description{margin-top:.5rem;max-width:35ch;font-size:.875rem;line-height:1.25rem;--tw-text-opacity: 1;color:rgb(var(--tsl-color-neutral-700) / var(--tw-text-opacity, 1))}tsl-vertical-tab-group .tab-description:is(.tsl-dark *){--tw-text-opacity: 1;color:rgb(var(--tsl-color-neutral-300) / var(--tw-text-opacity, 1))}tsl-vertical-tab-group .tabs-container{display:grid;grid-template-columns:repeat(1,minmax(0,1fr));grid-template-rows:repeat(1,minmax(0,1fr));--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-50) / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group .tabs-container:is(.tsl-dark *){--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-700) / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group .tab-container{grid-column-start:1;grid-row-start:1;padding:1rem;transition-property:opacity;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}}\n"], dependencies: [{ kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "pipe", type: DynamicTextPipe, name: "dynamicText" }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "component", type: IconComponent, selector: "tsl-icon", inputs: ["icon", "size"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: VerticalTabGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tsl-vertical-tab-group', imports: [NgTemplateOutlet, DynamicTextPipe, NgClass, IconComponent], changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, host: {
                        class: 'tsl-tw'
                    }, template: "<div class=\"border-r self-stretch\">\n  @if (title(); as title) {\n    <div class=\"tab-title-container\">\n      <div>{{ title | dynamicText }}</div>\n    </div>\n  }\n\n  <div>\n    @for (tab of tabs(); track tab) {\n      <div class=\"tab\" (click)=\"selectedTabIndex.set(tabs().indexOf(tab))\" [class.tab-selected]=\"tab == selectedTab()\">\n        <div class=\"flex items-center gap-2\">\n          @if (tab.icon(); as icon) {\n            <tsl-icon [icon]=\"icon\" size=\"2xl\"></tsl-icon>\n          }\n          <div class=\"tab-label\">\n            @if (tab.labelTemplateRef(); as labelTemplateRef) {\n              <ng-container [ngTemplateOutlet]=\"labelTemplateRef\"></ng-container>\n            } @else {\n              {{ tab.label() | dynamicText }}\n            }\n          </div>\n        </div>\n\n        @if (tab.description(); as description) {\n          <div class=\"tab-description\">{{ description | dynamicText }}</div>\n        }\n      </div>\n    }\n  </div>\n</div>\n\n<div class=\"tabs-container\">\n  @for (tab of tabs(); let index = $index; track tab) {\n    <div\n      class=\"tab-container\"\n      [class.opacity-0]=\"index != selectedTabIndex()\"\n      [class.pointer-events-none]=\"index != selectedTabIndex()\"\n      [attr.inert]=\"index != selectedTabIndex() ? true : null\"\n      [ngClass]=\"tab.class()\">\n      <ng-container [ngTemplateOutlet]=\"tab.contentTemplate() ?? null\"></ng-container>\n    </div>\n  }\n</div>\n", styles: ["@layer tstdl.components{tsl-vertical-tab-group{display:grid;grid-template-columns:auto 1fr;--tw-bg-opacity: 1;background-color:rgb(255 255 255 / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group:is(.tsl-dark *){--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-800) / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group .tab{position:relative;cursor:pointer;border-bottom-width:1px;padding:1rem 1.5rem}tsl-vertical-tab-group .tab:last-child{border-bottom-width:0px}tsl-vertical-tab-group .tab:not(.tab-selected):hover{--tw-bg-opacity: 1;background-color:rgb(255 251 235 / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group .tab:not(.tab-selected):is(.tsl-dark *):hover{background-color:rgb(var(--tsl-color-neutral-500) / .2)}tsl-vertical-tab-group .tab-selected{--tw-bg-opacity: 1;background-color:rgb(254 243 199 / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group .tab-selected:after{position:absolute;right:0;top:0;bottom:0;border-color:rgb(var(--tsl-color-neutral-500) / .8);content:var(--tw-content);transition-property:border;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}tsl-vertical-tab-group .tab-selected:is(.tsl-dark *){--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-700) / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group .tab-selected:is(.tsl-dark *):after{content:var(--tw-content);border-right-width:1px}tsl-vertical-tab-group .tab-selected .tab-label{--tw-text-opacity: 1;color:rgb(217 119 6 / var(--tw-text-opacity, 1))}tsl-vertical-tab-group .tab-selected .tab-label:is(.tsl-dark *){--tw-text-opacity: 1;color:rgb(245 158 11 / var(--tw-text-opacity, 1))}tsl-vertical-tab-group .tab-title-container{border-bottom-width:1px;padding:1.5rem;font-size:1.875rem;line-height:2.25rem;font-weight:700}tsl-vertical-tab-group .tab-label{font-weight:600}tsl-vertical-tab-group .tab-description{margin-top:.5rem;max-width:35ch;font-size:.875rem;line-height:1.25rem;--tw-text-opacity: 1;color:rgb(var(--tsl-color-neutral-700) / var(--tw-text-opacity, 1))}tsl-vertical-tab-group .tab-description:is(.tsl-dark *){--tw-text-opacity: 1;color:rgb(var(--tsl-color-neutral-300) / var(--tw-text-opacity, 1))}tsl-vertical-tab-group .tabs-container{display:grid;grid-template-columns:repeat(1,minmax(0,1fr));grid-template-rows:repeat(1,minmax(0,1fr));--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-50) / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group .tabs-container:is(.tsl-dark *){--tw-bg-opacity: 1;background-color:rgb(var(--tsl-color-neutral-700) / var(--tw-bg-opacity, 1))}tsl-vertical-tab-group .tab-container{grid-column-start:1;grid-row-start:1;padding:1rem;transition-property:opacity;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}}\n"] }]
        }], ctorParameters: () => [] });

class TslVerticalTabGroupModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: TslVerticalTabGroupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.9", ngImport: i0, type: TslVerticalTabGroupModule, imports: [VerticalTabGroupComponent, VerticalTabComponent, VerticalTabLabelDirective], exports: [VerticalTabGroupComponent, VerticalTabComponent, VerticalTabLabelDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: TslVerticalTabGroupModule, imports: [VerticalTabGroupComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.9", ngImport: i0, type: TslVerticalTabGroupModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [VerticalTabGroupComponent, VerticalTabComponent, VerticalTabLabelDirective],
                    exports: [VerticalTabGroupComponent, VerticalTabComponent, VerticalTabLabelDirective]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { TslVerticalTabGroupModule, VerticalTabComponent, VerticalTabGroupComponent, VerticalTabLabelDirective };
//# sourceMappingURL=tstdl-angular-vertical-tab-group.mjs.map
