import { CdkOverlayOrigin } from '@angular/cdk/overlay';
import { type ControlValueAccessor } from '@angular/forms';
import { SelectOptionComponent } from './select-option/select-option.component';
import * as i0 from "@angular/core";
export declare class SelectComponent<T> implements ControlValueAccessor {
    #private;
    readonly overlayTrigger: CdkOverlayOrigin;
    readonly value: import("@angular/core").ModelSignal<T | null>;
    readonly open: import("@angular/core").ModelSignal<boolean>;
    readonly disabledInput: import("@angular/core").ModelSignal<boolean | "" | "false" | "true" | null>;
    readonly disabled: import("@angular/core").Signal<boolean>;
    readonly options: import("@angular/core").Signal<readonly SelectOptionComponent<T>[]>;
    readonly selectedOption: import("@angular/core").Signal<SelectOptionComponent<T> | null>;
    readonly commonLocalizationKeys: import("@tstdl/base/text").ProxyLocalizationKeys<{
        firstName: import("@tstdl/base/text").LocalizeItem;
        lastName: import("@tstdl/base/text").LocalizeItem;
        mailAddress: import("@tstdl/base/text").LocalizeItem;
        password: import("@tstdl/base/text").LocalizeItem;
        confirmPassword: import("@tstdl/base/text").LocalizeItem;
        notSpecified: import("@tstdl/base/text").LocalizeItem;
        select: import("@tstdl/base/text").LocalizeItem;
        yes: import("@tstdl/base/text").LocalizeItem;
        no: import("@tstdl/base/text").LocalizeItem;
        ok: import("@tstdl/base/text").LocalizeItem;
        success: import("@tstdl/base/text").LocalizeItem;
        cancel: import("@tstdl/base/text").LocalizeItem;
        add: import("@tstdl/base/text").LocalizeItem;
        save: import("@tstdl/base/text").LocalizeItem;
        remove: import("@tstdl/base/text").LocalizeItem;
    }>;
    get overlayWidth(): number;
    get id(): string;
    set id(id: string);
    onClick(): void;
    toggle(): void;
    select(value: T | null): void;
    selectOption(option: SelectOptionComponent<T>): void;
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState?(isDisabled: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SelectComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SelectComponent<any>, "button[tslSelect]", never, { "value": { "alias": "value"; "required": false; "isSignal": true; }; "open": { "alias": "open"; "required": false; "isSignal": true; }; "disabledInput": { "alias": "disabled"; "required": false; "isSignal": true; }; }, { "value": "valueChange"; "open": "openChange"; "disabledInput": "disabledChange"; }, ["options"], ["*"], true, never>;
}
