import type { OnChanges, OnDestroy, OnInit, Signal, SimpleChanges } from '@angular/core';
import type { Record, Type } from '@tstdl/base/types';
import type { FunctionComponent, Component as PreactComponent } from 'preact';
import * as i0 from "@angular/core";
export declare class ReactComponent<Properties extends Record = any, State = any> implements OnInit, OnChanges, OnDestroy {
    private readonly elementRef;
    private readonly changeDetector;
    private readonly injector;
    private readonly adaptSignal;
    private readonly wrapFunction;
    private propertiesEffectRef;
    component: FunctionComponent<Properties> | Type<PreactComponent<Properties, State>>;
    properties: Properties | Signal<Properties>;
    /** adapt angular signals to preact signals (readonly) */
    adaptSignals: boolean;
    /** wrap functions in properties (1st level only) to run change detection afterwards */
    wrapFunctions: boolean;
    get propertiesValue(): Properties;
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    render(): void;
    private prepareProperties;
    static ɵfac: i0.ɵɵFactoryDeclaration<ReactComponent<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ReactComponent<any, any>, "tsl-react", never, { "component": { "alias": "component"; "required": false; }; "properties": { "alias": "properties"; "required": false; }; "adaptSignals": { "alias": "adaptSignals"; "required": false; }; "wrapFunctions": { "alias": "wrapFunctions"; "required": false; }; }, {}, never, never, true, never>;
}
