import { type AfterViewInit, ChangeDetectorRef, ElementRef } from '@angular/core';
import { LifecycleUtils } from '../utils/lifecycle';
import * as i0 from "@angular/core";
type ElementOrElementRef = Element | ElementRef<Element>;
export declare class LazyListDirective<T> extends LifecycleUtils<LazyListDirective<T>> implements AfterViewInit {
    private readonly changeDetector;
    private readonly scrollElementSubject;
    private checking;
    private readonly scrollElement$;
    private readonly observeElement$;
    items: T[];
    /**
     * Items to lazily append to {@link items}
     */
    source: T[];
    /**
     * How many items to add at the first tick
     * @default 1
     */
    initialSize: number;
    /**
     * How many items to add at once per tick
     * @default 1
     */
    batchSize: number;
    /**
     * How far to preload items. Percentage of scroll elements client height
     * @default 50
     */
    margin: number;
    /**
     * Element to observe for scrolling and load items when at end
     */
    scrollElement: ElementOrElementRef | undefined;
    /**
     * Element to observe for intersection with the scroll element to trigger at tick
     */
    observeElement: ElementOrElementRef | undefined;
    get thresholdReached(): boolean;
    get hasAll(): boolean;
    constructor(elementRef: ElementRef<Node>, changeDetector: ChangeDetectorRef);
    ngAfterViewInit(): void;
    check(): Promise<void>;
    add(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<LazyListDirective<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<LazyListDirective<any>, "[tslLazyList]", ["lazyList"], { "source": { "alias": "tslLazyList"; "required": false; }; "initialSize": { "alias": "lazyInitialSize"; "required": false; }; "batchSize": { "alias": "lazyBatchSize"; "required": false; }; "margin": { "alias": "lazyMargin"; "required": false; }; "scrollElement": { "alias": "lazyScrollElement"; "required": false; }; "observeElement": { "alias": "lazyObserveElement"; "required": false; }; }, {}, never, never, true, never>;
}
export {};
