import { TemplateRef, type OnDestroy } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * Lazily render the element when it intersects the viewport (default) or specified {@link root} element.
 * {@link rootMargin} (default 25%) and {@link threshold} (0) can be specified.
 * Uses a div of size {@link intrinsicWidth} and {@link intrinsicHeight} to track visibility using {@link IntersectionObserver}
 */
export declare class LazyDirective implements OnDestroy {
    private readonly destroyRef;
    private readonly templateRef;
    private readonly viewContainer;
    private readonly elementRef;
    private readonly renderer;
    private readonly changeDetector;
    private intersectionTracker;
    private initialTemplateView;
    readonly root: import("@angular/core").InputSignal<Element | Document | null | undefined>;
    readonly rootMargin: import("@angular/core").InputSignal<string | undefined>;
    readonly threshold: import("@angular/core").InputSignalWithTransform<number | number[] | null | undefined, number | `${number}` | number[] | null | undefined>;
    readonly intrinsicWidth: import("@angular/core").InputSignal<string | null | undefined>;
    readonly intrinsicHeight: import("@angular/core").InputSignal<string | null | undefined>;
    /**
     * Template to render before actual deferred view. Useful for eg. for skeletons.
     * Should be lightweight/fast to render
     */
    readonly initialTemplate: import("@angular/core").InputSignal<TemplateRef<any> | null | undefined>;
    /**
     * Insert intersection tracker
     * true: insert even if `initialTemplate` is provided,
     * false: only insert if no initialTemplate is provided (default)
     */
    readonly tracker: import("@angular/core").InputSignalWithTransform<boolean, boolean | "false" | "true">;
    constructor();
    ngOnDestroy(): void;
    private removeTracker;
    static ɵfac: i0.ɵɵFactoryDeclaration<LazyDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<LazyDirective, "[tslLazy]", never, { "root": { "alias": "tslLazyRoot"; "required": false; "isSignal": true; }; "rootMargin": { "alias": "tslLazyRootMargin"; "required": false; "isSignal": true; }; "threshold": { "alias": "tslLazyThreshold"; "required": false; "isSignal": true; }; "intrinsicWidth": { "alias": "tslLazyIntrinsicWidth"; "required": false; "isSignal": true; }; "intrinsicHeight": { "alias": "tslLazyIntrinsicHeight"; "required": false; "isSignal": true; }; "initialTemplate": { "alias": "tslLazyInitialTemplate"; "required": false; "isSignal": true; }; "tracker": { "alias": "tslLazyTracker"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
