import type { OnDestroy, Signal } from '@angular/core';
import type { Observable, ReadableStreamLike } from 'rxjs';
import * as i0 from "@angular/core";
export type LetContext<T> = {
    $implicit: LetOutput<T>;
    tslLet: LetOutput<T>;
    isComplete: boolean;
    hasError: boolean;
    error: any;
};
type LetAsyncInput<T> = Observable<T> | AsyncIterable<T> | PromiseLike<T> | ReadableStreamLike<T> | Signal<T>;
type LetInput<T> = LetAsyncInput<T> | T;
type LetOutput<T> = T extends LetAsyncInput<infer U> ? U : T;
export declare class LetDirective<T> implements OnDestroy {
    static ngTemplateGuard_tslLet: 'binding';
    private readonly template;
    private readonly viewContainer;
    private readonly changeDetector;
    private readonly injector;
    private readonly errorHandler;
    private readonly inputSubject;
    private readonly viewContext;
    private readonly subscription;
    private embeddedView;
    set tslLet(observableInput: LetInput<T>);
    static ngTemplateContextGuard<T>(_directive: LetDirective<T>, _context: LetContext<T>): _context is LetContext<T>;
    next(value: LetOutput<T>): void;
    error(error: unknown): void;
    complete(): void;
    updateEmbeddedView(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<LetDirective<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<LetDirective<any>, "[tslLet]", never, { "tslLet": { "alias": "tslLet"; "required": false; }; }, {}, never, never, true, never>;
}
export {};
