import type { OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { ElementRef, EventEmitter, Renderer2 } from '@angular/core';
import type { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare class VisibilityObserverDirective implements OnDestroy, OnInit, OnChanges {
    private readonly renderer;
    private readonly isVisibleSubject;
    private readonly visibilitySubject;
    private observer;
    readonly elementRef: ElementRef<HTMLElement>;
    readonly isVisible$: Observable<boolean>;
    readonly visibility$: Observable<number>;
    dataAttribute: string | undefined;
    treshold: number;
    margin: string;
    root: HTMLElement | number | null | undefined;
    visible: EventEmitter<ElementRef>;
    isVisibleChanged: EventEmitter<boolean>;
    visibilityChanged: EventEmitter<number>;
    get isVisible(): boolean;
    get visibility(): number;
    constructor(elementRef: ElementRef, renderer: Renderer2);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onObserve(entries: IntersectionObserverEntry[]): void;
    ngOnDestroy(): void;
    private setupObserver;
    private unobserve;
    static ɵfac: i0.ɵɵFactoryDeclaration<VisibilityObserverDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<VisibilityObserverDirective, "[visibilityObserver]", ["visibilityObserver"], { "dataAttribute": { "alias": "visibilityObserver"; "required": false; }; "treshold": { "alias": "visibilityTreshold"; "required": false; }; "margin": { "alias": "visibilityMargin"; "required": false; }; "root": { "alias": "visibilityRoot"; "required": false; }; }, { "visible": "visible"; "isVisibleChanged": "isVisibleChanged"; "visibilityChanged": "visibilityChanged"; }, never, never, true, never>;
}
