import type { Provider, ProviderToken } from '@angular/core';
import { Injector } from '@angular/core';
import type { Injector as TstdlInjector } from '@tstdl/base/injector';
export declare abstract class R3Injector extends Injector {
    records: R3InjectorRecordsMap;
    processProvider(provider: Provider): void;
}
export type R3InjectorRecordsMap = Map<ProviderToken<any>, any>;
export declare class WrappedR3InjectorRecordsMap implements R3InjectorRecordsMap {
    #private;
    private readonly r3Injector;
    private readonly records;
    get size(): number;
    get [Symbol.toStringTag](): string;
    constructor(injector: TstdlInjector, r3Injector: R3Injector, records: R3InjectorRecordsMap);
    static wrap(injector: TstdlInjector, r3Injector: R3Injector): void;
    clear(): void;
    delete(key: ProviderToken<any>): boolean;
    forEach(callbackfn: (value: any, key: ProviderToken<any>, map: R3InjectorRecordsMap) => void, thisArg?: any): void;
    get(key: ProviderToken<any>): any;
    has(key: ProviderToken<any>): boolean;
    set(key: ProviderToken<any>, value: any): this;
    entries(): MapIterator<[ProviderToken<any>, any]>;
    keys(): MapIterator<ProviderToken<any>>;
    values(): MapIterator<any>;
    [Symbol.iterator](): MapIterator<[ProviderToken<any>, any]>;
    private addIfPossible;
}
