import { ComponentPortal, TemplatePortal } from '@angular/cdk/portal';
import { ComponentRef, EmbeddedViewRef, type OnDestroy, TemplateRef } from '@angular/core';
import type { DynamicText } from '@tstdl/base/text';
import type { Type } from '@tstdl/base/types';
import * as i0 from "@angular/core";
export declare class TooltipDirective<Component extends Type, Context> implements OnDestroy {
    private readonly elementRef;
    private readonly viewContainerRef;
    private readonly overlay;
    private readonly overlayPositionBuilder;
    private readonly positionStrategy;
    private readonly subscription;
    private overlayRef;
    content: DynamicText | Component | TemplateRef<Context> | ComponentPortal<Component> | TemplatePortal<Context> | null;
    tooltipContainer: boolean;
    tooltipContext: Context | null | undefined;
    tooltipDelay: number;
    tooltipComponentRef: ComponentRef<Component> | undefined;
    tooltipViewRef: EmbeddedViewRef<Context> | undefined;
    constructor();
    ngOnDestroy(): void;
    show(): void;
    hide(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TooltipDirective<any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TooltipDirective<any, any>, "[tslTooltip]", never, { "content": { "alias": "tslTooltip"; "required": false; }; "tooltipContainer": { "alias": "tooltipContainer"; "required": false; }; "tooltipContext": { "alias": "tooltipContext"; "required": false; }; "tooltipDelay": { "alias": "tooltipDelay"; "required": false; }; }, {}, never, never, true, never>;
}
